package CounterDemo;

import javax.swing.AbstractButton;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JFrame;
import javax.swing.ImageIcon;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;

public class Control extends JPanel implements ActionListener {
    protected JButton b1, b2, b3, b4;
    CounterObserver screen, console;
    protected Counter counter;

    public Control(Counter c, CounterObserver so, CounterObserver co) {
        counter = c;
	screen = so;
	console = co;
        javax.swing.SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                createAndShowGUI(); 
            }
        });
    }

    public void initialize() {
        b1 = new JButton("Incrémente");
        b1.setActionCommand("increment");

        b2 = new JButton("Décrémente");
        b2.setActionCommand("decrement");

        b3 = new JButton("Fenêtre");
        b3.setActionCommand("screen");

        b4 = new JButton("Console");
        b4.setActionCommand("console");

        b1.addActionListener(this);
        b2.addActionListener(this);
        b3.addActionListener(this);
        b4.addActionListener(this);

        b1.setToolTipText("Incrémente le compteur");
        b2.setToolTipText("Décrémente le compteur");
        b3.setToolTipText("Affiche le résultat sur la fenêtre");
        b4.setToolTipText("Affiche le résultat sur la console");

        //Add Components to this container, using the default FlowLayout.
        add(b1);
        add(b2);
        add(b3);
        add(b4);
    }

    public void actionPerformed(ActionEvent e) {
        if ("increment".equals(e.getActionCommand())) {
		counter.increment();
	} else if ("decrement".equals(e.getActionCommand())) {
	    counter.decrement();
	} else if ("screen".equals(e.getActionCommand())) {
	    counter.setObserver(screen);
	} else if ("console".equals(e.getActionCommand())) {
	    counter.setObserver(console);
	}
    }
    

    /**
     * Create the GUI and show it.  For thread safety, 
     * this method should be invoked from the 
     * event-dispatching thread.
     */
    private void createAndShowGUI() {
        //Make sure we have nice window decorations.
        JFrame.setDefaultLookAndFeelDecorated(true);

        //Create and set up the window.
        JFrame frame = new JFrame("Exemple MVC Counter");
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

        //Create and set up the content pane.
	initialize();
        this.setOpaque(true); //content panes must be opaque
        frame.setContentPane(this);

        //Display the window.
        frame.pack();
        frame.setVisible(true);
    }
}
